import App
import Foundation
import MissionLib
import nt
import string
import sys
import traceback
MODINFO = { "Author": "Glen Fletcher (glenflet)",
            "Version": "1.0",
            "License": "GPL",
            }
Me = Foundation.MutatorDef("Realstic Technology")
def Load(pMode):
	if (pMode==1):
		print("###########################################################################")
		print("Realistic Technology Loaded at %s") % (time.asctime(time.localtime(time.time())))
		print("###########################################################################")
	dir = "scripts\\Custom\\RealTech"
	addonsLoaded = {}
	list = nt.listdir(dir)
	list.sort()
	dotPrefix = string.join(string.split(dir, '\\')[1:], '.') + '.'
	for addon in list:
		s = string.split(addon, '.')
		if len(s) <= 1:
			continue
		extension = s[-1]
		addonfile = string.join(s[:-1], '.')
		if (addonfile == "__init__"):
			continue
		if (((extension == 'py') or (extension == 'pyc')) and (not addonsLoaded.has_key(addonfile))):
			addonsLoaded[addonfile] = 1
			try:
					AddonScript = __import__(dotPrefix + addonfile)
			except:
					errtype, errinfo, errtrace = sys.exc_info()
					print("Error: was unable to load %s - %s: %s")%(addonfile, errtype, errinfo)
					fulltrace = traceback.print_exc(errtrace)
					if fulltrace:
							print("Traceback: %s")%(fulltrace)
					continue
						if (pMode==1) and (hasattr(AddonScript, "Load")) and Active:
							AddonScript.Load()
						if (pMode==2) and (hasattr(AddonScript, "Start")) and Active:
							AddonScript.Start()
	return

class RealsticTechnology_Load(Foundation.TriggerDef):
			def __init__(self, name, eventKey, dict = {}):
				Foundation.TriggerDef.__init__(self, name, eventKey, dict)
				Load(1)
				print("Realstic Technology Loaded")                
			def __call__(self, name, eventKey, dict = {}):
				print("Realstic Technology Starting and Loading Addons....")
				Load(2)
				print("Realstic Technology Started")
				print("Addons Loaded")
RealsticTechnology_Load('RealsticTechnology', App.ET_MISSION_START, dict = { 'modes': [ Me ]} )
